=== debian/changelog ===
spring (0.81.2.1+dfsg1-6) unstable; urgency=low

  * debian/control: remove dependency on python-dev-2.5

 -- Jan Dittberner <jandd@debian.org>  Sat, 29 May 2010 16:29:52 +0200

spring (0.81.2.1+dfsg1-5) unstable; urgency=low

  * debian/patches/0002-use-Debian-java-libs.patch:
    - remove empty ${myJLibDir} from classpath in
      AI/Interfaces/Java/CMakeLists.txt and
      AI/Skirmish/HughAI/CMakeLists.txt
    - use -classpath instead of -cp
  * refresh debian/patches/0001-Minor-spelling-fix.patch
  * debian/control: restrict supported architectures to i386 and amd64
    because building fails on kfreebsd-* due to no capable enough JDK
    and hardware accellerated OpenGL requirement
  * debian/rules: fail in override_dh_auto_configure if architecture is
    not amd64 or i386

 -- Jan Dittberner <jandd@debian.org>  Sat, 29 May 2010 01:20:21 +0200

spring (0.81.2.1+dfsg1-4) unstable; urgency=low

  * add debian/spring-javaai.links to add links to jna.jar and vecmath.jar

 -- Jan Dittberner <jandd@debian.org>  Fri, 16 Apr 2010 23:12:29 +0200

spring (0.81.2.1+dfsg1-3) unstable; urgency=low

  * enable Java-AI-Interface
   - debian/control: add libvecmath-java and libjna-java to Build-Depends
   - debian/rules: remove -DAI_TYPES=NATIVE configure argument, add
     -DAI_FIND_QUIETLY=FALSE
   - add debian/patches/0002-use-Debian-java-libs.patch to use jar files
     from libvecmath-java and libjna-java
   - add debian/patches/0003-fix-cmake-2_8-java-build.patch to fix cmake 2.8
     java compilation issue
  * add new binary package spring-javaai
   - add package stanza to debian/control
   - add paths to debian/spring-javaai.install
  * add spring-javaai to spring binary package's Suggests in debian/control
  * refine debian/spring-common.install to exclude Java AI files from
    spring-common
  * debian/control: remove libgcj9-dev from Build-Depends, it is not
    available anymore and not necessary (Closes: #577885)

 -- Jan Dittberner <jandd@debian.org>  Fri, 16 Apr 2010 18:41:38 +0200

spring (0.81.2.1+dfsg1-2) unstable; urgency=low

  * use FreeSansBold.otf from otf-freefont (Closes: #575512)
   - debian/control: depend on otf-freefont instead of ttf-freefont
   - debian/rules: symlink to otf version of FreeSansBold

 -- Jan Dittberner <jandd@debian.org>  Mon, 05 Apr 2010 00:02:31 +0200

spring (0.81.2.1+dfsg1-1) unstable; urgency=low

  * New upstream version

 -- Jan Dittberner <jandd@debian.org>  Thu, 25 Mar 2010 21:15:03 +0100

spring (0.81.2+dfsg1-1) unstable; urgency=low

  * New upstream version
  * debian/rules, debian/watch: use +dfsg instead of ~dfsg for correct
    sorting

 -- Jan Dittberner <jandd@debian.org>  Mon, 22 Feb 2010 22:13:14 +0100

spring (0.81.1.3~dfsg1-1) unstable; urgency=low

  [ Marco Amadori ]
  * Imported Upstream version 0.81.1.3
  * Set -march=i686 only on i386 (Helps: #563686).
  * Adapted DATADIR paths to relative ones
  * Bumped Standards-Version to 3.8.4.

  [ Jan Dittberner ]
  * repack tarball in a get-orig-source rule
  * add dversionmangle to debian/watch
  * move information from debian-removed.txt to debian/README.source
  * debian/control:
   - add myself to Uploaders
   - set Architecture for spring and spring-dbg to i386 amd64
     kfreebsd-i386 kfreebsd-amd64 hurd-i386 because of x86 only assembly in
     rts/lib/streflop/streflopC.cpp
   - remove Build-Depends quilt
  * add doc-base registration files debian/spring.doc-base.devguide and
    debian/spring.doc-base.minihelp for included HTML documentation
  * add debian/source/format with content "3.0 (quilt)"
  * remove quilt information from debian/README.source
  * debian/rules: remove " --with quilt"

 -- Jan Dittberner <jandd@debian.org>  Sat, 20 Feb 2010 18:02:42 +0100

spring (0.80.5.2-2) unstable; urgency=low

  * Added the -dbg debug package (Closes: #564049).
  * Removed spring-common circular Depends (Closes: #562711).
  * Renabled Quilt for including a git upstream licence patch.
  * Allow builds without SSE (Closes: #563686).
  * Improved copyright file (Closes: #563739).

 -- Marco Amadori <marco.amadori@gmail.com>  Thu, 14 Jan 2010 02:17:08 +0100

spring (0.80.5.2-1) unstable; urgency=low

  * Initial release (Closes: #367883).
  * Thanks to Scott Ritchie <scottritchie@ubuntu.com> and Chris Clearwater
    <chris@detrino.org> for their MOTU packaging which gave me a couple of
    hints.
  * This release do not include the Java AI interface due to a couple of
    sourceless jar distributed in the upstream tarball that are stripped in
    this packaging.
 -- Marco Amadori <marco.amadori@gmail.com>  Sat, 28 Nov 2009 23:55:25 +0100
